*Programme strukturieren

*denkbare Erweiterungen
* Kontrolle, ob bei Beginn von Funktionen oder Prozeduren der Stapel auf Null ist
* zurckrcken und Kontrollieren von BREAK und RECOVER (hnlich fwsuch())
* Schreiben von WHILE oder FOR mit der Zeilennummer hinter LOOP und EXIT als Kommentar mit Updatefhigkeit


*DO CASE ... CASE ... ENDCASE
*IF ... ELSEIF ... ENDIF
*DO WHILE ... ENDD ... LOOP ... EXIT
*FOR ... NEXT ... LOOP ... EXIT
*BEGIN SEQUENCE ... END SEQUENCE

#define MCASE "C"
#define MIF "I"
#define MWHILE "W"
#define MFOR "F"
#define MSEQ "S"

static stapel:={}

proc main
local vh,zh,err:=.f.,t,t1
local zname && Zielname
local znr:=1 && Zeilennumer
para vname && Von-Name
*memvar vname
? "PRGSTRU - Heiners PRG-Datei-Strukturierer"
if empty(vname)
 quit
endi

cls

zname := std_typ(vname,"PRG") // zname:=upper(std_typ(vname,"PRG"))

if ! file( zname )
? zname + " nicht gefunden"
quit
endi

vname := zname + ".BAK" // vname := vname + ".BAK" // neue BAK-Mimik wie unter Windows ueblich     vname:=upper(std_typ(strip_ext(vname),"BAK"))

/*
if zname=vname
 ? "*.BAK-Dateien knnen nicht strukturiert werden"
 quit
endi
*/

*? "Sico to",vname

FileCopy( zname , vname )
vh=fopen(vname)
zh=fcreate(zname)
do while !bineof(vh)
 t:=alltrim(freadln(vh))
 do case
 case err && Einfach nur noch laufen lassen
 case upper(t)="DO CASE"
  t=space(len(stapel))+t
  aadd(stapel,MCASE)
 case upper(t)="CASE ".or.upper(t)="OTHE"
  if len(stapel)>0.and.atail(stapel)=MCASE
   t=space(len(stapel)-1)+t
  else
   ? erwtxt(),znr
   t=erwtxt()+t
   err=.t.
  endi
 case upper(t)="ENDC".or.upper(t)="ENDCASE"
  if len(stapel)>0.and.atail(stapel)=MCASE
   asize(stapel,len(stapel)-1)
   t=space(len(stapel))+t
  else
   ? erwtxt(),znr
   t=erwtxt()+t
   err=.t.
  endi
 case upper(t)="IF "
  t=space(len(stapel))+t
  aadd(stapel,MIF)
 case upper(t)="ELSEIF ".or.upper(t)="ELSE"
  if len(stapel)>0.and.atail(stapel)=MIF
   t=space(len(stapel)-1)+t
  else
   ? erwtxt(),znr
   t=erwtxt()+t
   err=.t.
  endi
 case upper(t)="ENDIF".or.upper(t)="ENDI"
  if len(stapel)>0.and.atail(stapel)=MIF
   asize(stapel,len(stapel)-1)
   t=space(len(stapel))+t
  else
   ? erwtxt(),znr
   t=erwtxt()+t
   err=.t.
  endi
 case upper(t)="DO WHILE ".or.upper(t)="DO WHIL ".or.upper(t)="WHILE ".or.upper(t)="WHIL "
  t=space(len(stapel))+t
  aadd(stapel,MWHILE)
 case upper(t)="ENDD".or.upper(t)="ENDDO"
  if len(stapel)>0.and.atail(stapel)=MWHILE
   asize(stapel,len(stapel)-1)
   t=space(len(stapel))+t
  else
   ? erwtxt(),znr
   t=erwtxt()+t
   err=.t.
  endi
 case upper(t)="FOR "
  t=space(len(stapel))+t
  aadd(stapel,MFOR)
 case upper(t)="NEXT"
  if len(stapel)>0.and.atail(stapel)=MFOR
   asize(stapel,len(stapel)-1)
   t=space(len(stapel))+t
  else
   ? erwtxt(),znr
   t=erwtxt()+t
   err=.t.
  endi
 case upper(t)="EXIT".or.upper(t)="LOOP"
  if (t1:=fwsuch())>0
   t=space(t1-1)+t
  else
   ? erwtxt(),znr
   t=erwtxt()+t
   err=.t.
  endi
 case upper(t)="BEGIN SEQU"
  t=space(len(stapel))+t
  aadd(stapel,MSEQ)
 case upper(t)="END SEQU"
  if len(stapel)>0.and.atail(stapel)=MSEQ
   asize(stapel,len(stapel)-1)
   t=space(len(stapel))+t
  else
   ? erwtxt(),znr
   t=erwtxt()+t
   err=.t.
  endi
 case upper(t)="BREAK".or.upper(t)="RECOVER"
  t=space(len(stapel)-1)+t
 othe
  t=space(len(stapel))+t
 endc
 fwriteln(zh,t)
znr++
endd
fclose(vh)
if !err
 do while len(stapel)>0
  fwriteln(zh,erwtxt())
  ? erwtxt(),znr
  asize(stapel,len(stapel)-1)
 endd
endi
fclose(vh)
fclose(zh)

*************
static func erwtxt && xxx erwartet Text
local t
do case
case len(stapel)<1
t="KEIN STRUKTURBEFEHL"
case atail(stapel)=MCASE
 t="ENDCASE"
case atail(stapel)=MIF
 t="ENDIF"
case atail(stapel)=MWHILE
 t="ENDDO"
case atail(stapel)=MFOR
 t="NEXT"
case atail(stapel)=MSEQ
 t="END SEQUENCE"
endc

t+=" erwartet => "
retu(t)
************
static func fwsuch && FOR oder WHILE im Stapel suchen
local i
if len(stapel)>0
 for i:=len(stapel) to 1 step -1
  if stapel[i]=MWHILE.or.stapel[i]=MFOR
   retu(i)
  endi
 next
endi
retu(0)
*************
